# Pinephone Compass <img src="data/icons/hicolor/scalable/apps/com.gitlab.lgtrombetta.Compass.svg" alt="Pinephone Compass" title="" width="40" height="40" />

This is a simple GTK3 compass app for the Pine64 Pinephone. It was tested on Phosh (Manjaro, Mobian and postmarketOS), but it should run on any distro that has the proper dependencies.

The app fully supports the original LIS3MDL magnetometer chip (pre-beta Pinephone editions up to Q4 2020). 

Preliminary support for the new magnetometer chip AF8133J (Pinephone Beta edition) has also been added in preparation for the upstreaming of its driver plus extra patches (see <a href="https://gitlab.com/pine64-org/linux/-/merge_requests/25">https://gitlab.com/pine64-org/linux/-/merge_requests/25</a>).

<img src="data/screenshot.png" alt="Pinephone Compass" title="" width=20% height=auto />

---

### Dependencies

The app uses meson build system. Some packages are needed:

Manjaro:
```
sudo pacman -S meson pkgconf python-numpy python-matplotlib python-pandas
```
Mobian:
```
sudo apt install git meson gettext appstream-util libglib2.0-dev python3-numpy python3-matplotlib python3-pandas
```
postmarketOS:
```
sudo apk add git meson gettext glib-dev py3-numpy py3-matplotlib py3-pandas py3-xdg
```

The Python modules above can alternatively be installed via `pip`

### Installation

```
git clone https://gitlab.com/lgtrombetta/pinephone-compass.git
cd pinephone-compass
meson build
cd build
sudo ninja install
```

### Running the app

You can simply start the app from its launcher: <img src="data/icons/hicolor/scalable/apps/com.gitlab.lgtrombetta.Compass.svg" alt="Pinephone Compass" title="" width="25" height="25" />

Alternatively, you can run the app from the terminal with `pinephone-compass`

### Magnetometer Calibration

The reading of the magnetometer provided by the driver needs to be corrected to compensate for effects due to the hardware specifics of the Pinephone. The most important effect is a hardiron constant offset. Currently, the app performs this correction by sustracting the values `MAGN_X_OFFSET`, `MAGN_Y_OFFSET` and `MAGN_Z_OFFSET` which are defined in the configuration file `compass.conf`. These values can vary from device to device, and therefore it is necessary to perform a calibration run on each device at least once. You can do so by going to `Settings > Calibrate`.

The default duration will be `30` seconds. During this time, gently rotate your device around each of the 3 main axes repeatedly (try to do it on the same spot such that the total field intensity remains roughly constant). 

If the compass does not behave correctly for you, consider running the calibration again with a longer duration. Also, consider doing it on place away from external magnetic interference.

---

<div>Icons made by <a href="https://www.flaticon.com/authors/vectors-market" title="Vectors Market">Vectors Market</a> from <a href="https://www.flaticon.com/" title="Flaticon">www.flaticon.com</a></div>
